#include <string.h>
#include <stdlib.h>
#include "pdk.h"
#include "disasm.h"


int main(int argc, char **argv)
{
	if (argc < 2) {
		printf("Usage: pdisasm pdk [ io_symbols [ mem_symbols] ]\n");
		return 0;
	}

	if (!strcmp(argv[1], "16")) {
		CPadaukDisasm16::print_instruction_set();
	} else if (!strcmp(argv[1], "14")) {
		CPadaukDisasm14::print_instruction_set();
	} else if (!strcmp(argv[1], "13")) {
		CPadaukDisasm13::print_instruction_set();
	} else if (!strcmp(argv[1], "all")) {
		CPadaukDisasm::compare_opcodes();
	} else {
		CPDK pdk;
		int e;
		if ((e = pdk.read_file(argv[1]))) { 
			printf("Unable to open pdk file %s\nError %i\n", argv[1], e);
			return e;
		}

		auto d = CPadaukDisasm::New(pdk.bits);
		if (!d) { printf("Unsupported core (%i bits)\n", pdk.bits);  return -2; }

		if (argc > 2) d->io_symbols.ReadFile(argv[2]);
		if (argc > 3) d->mem_symbols.ReadFile(argv[3]);

		d->disasm(pdk);
	}
	return 0;
}
